package agency;

import java.rmi.*;
import java.sql.*;
import java.util.*;
import javax.ejb.*;
import javax.naming.* ;
import javax.sql.*;

import data.*;

public class ServiceBean implements SessionBean
{
    private ApplicantLocalHome applicantHome;
    private CustomerLocalHome customerHome;
    private JobLocalHome jobHome;
    private LocationLocalHome locationHome;
    private SkillLocalHome skillHome;

    public String[] findJobsAtLocation(String location)
    {
        String[] jobs = null;
	try
	{
        	Collection col = jobHome.findByLocation(location);
        	jobs = new String[col.size()];
        	Iterator it=col.iterator();
        	for (int i=0; i<jobs.length; ++i)
		{
            		JobLocal job = (JobLocal)it.next();
            		jobs[i] = job.getCustomer()+"/"+job.getRef();
        	}
	}
	catch (Exception ex)
	{
		// In response to any error just return null
		jobs = null;
	}
        return jobs;
    }
    
    public String[] findApplicantsAtLocation(String location)
    {
	String[] applicants = null;
	try
	{
        	Collection col = applicantHome.findByLocation(location);
        	applicants = new String[col.size()];
        	Iterator it=col.iterator();
        	for (int i=0; i<applicants.length; ++i)
		{
            		ApplicantLocal applicant = (ApplicantLocal)it.next();
            		applicants[i] = applicant.getLogin();
        	}
	}
	catch (Exception ex)
	{
		// In reposne to any error just return null
		applicants = null;
	}
        return applicants;
    }

    // EJB methods start here


    public void ejbCreate () throws CreateException {}

    public void ejbActivate(){}

    public void ejbPassivate(){}

    public void ejbRemove(){}

    private SessionContext ctx;

    public void setSessionContext(SessionContext ctx)
    {
        this.ctx = ctx;
        InitialContext ic = null;
        try
	{
            ic = new InitialContext();
            applicantHome = (ApplicantLocalHome)ic.lookup("java:comp/env/ejb/ApplicantLocal");
        }
        catch (NamingException ex)
	{
            error("Error looking up java:comp/env/ejb/ApplicantLocal",ex);
            return;
        }
        try
	{
            jobHome = (JobLocalHome)ic.lookup("java:comp/env/ejb/JobLocal");
        }
        catch (NamingException ex)
	{
            error("Error looking up java:comp/env/ejb/JobLocal",ex);
            return;
        }
    }
    
    private void error (String msg, Exception ex)
    {
        String s = "ServiceBean: "+msg + "\n" + ex;
        System.out.println(s);
        throw new EJBException(s,ex);
    }
}

