package client;

public class AgencyServiceClient
{
    private static String location = "%";

    public static void main(String[] args)
    {
        if (args.length == 1)
	{
            location = args[0];
	}
        else if (args.length > 1)
	{
            System.err.println("Usage: AgencyServiceClient [ location ]");
            System.exit(1);
        }

        try
	{
            AgencyService serviceProxy = new AgencyService_Impl();

            Service interfaceProxy = serviceProxy.getServicePort();

            System.out.println("Using Location: "+location);

            System.out.println("Job list: ");
            String[] jobs = interfaceProxy.findJobsAtLocation(location);
            for(int i=0; i<jobs.length; ++i)
	    {
                System.out.println(jobs[i]);
            }
            System.out.println();
            
            System.out.println("Applicant list: ");
            String[] applicants = interfaceProxy.findApplicantsAtLocation(location);
            for(int i=0; i<applicants.length; ++i)
	    {
                System.out.println(applicants[i]);
            }
            System.out.println("\nDone\n");
        }
	catch (Exception ex)
	{
            ex.printStackTrace();
        }
    }    
}
