package agency;

import java.util.*;
import java.rmi.*;
import javax.ejb.*;
import javax.naming.* ;

import data.*;

public class ServiceBean implements SessionBean
{
    private JobLocalHome jobHome;

    public String[] findJobsAtLocation(String location)
    {
        String[] jobs = null;
	try
	{
        	Collection col = jobHome.findByLocation(location);
        	jobs = new String[col.size()];
        	Iterator it=col.iterator();
        	for (int i=0; i<jobs.length; ++i)
		{
            		JobLocal job = (JobLocal)it.next();
            		jobs[i] = job.getCustomer()+"/"+job.getRef();
        	}
	}
	catch (Exception ex)
	{
		// In response to any error just return null
		jobs = null;
	}
        return jobs;
    }
    
    // EJB methods start here


    public void ejbCreate () throws CreateException {}

    public void ejbActivate(){}

    public void ejbPassivate(){}

    public void ejbRemove(){}

    private SessionContext ctx;

    public void setSessionContext(SessionContext ctx)
    {
        this.ctx = ctx;
        InitialContext ic = null;
        try
	{
            ic = new InitialContext();          
	    jobHome = (JobLocalHome)ic.lookup("java:comp/env/ejb/JobLocal");
        }
        catch (NamingException ex)
	{
            error("Error looking up java:comp/env/ejb/JobLocal",ex);
            return;
        }
    }
    
    private void error (String msg, Exception ex)
    {
        String s = "ServiceBean: "+msg + "\n" + ex;
        System.out.println(s);
        throw new EJBException(s,ex);
    }
}

