package client;

import java.net.URL;
import java.net.MalformedURLException;

import org.apache.xml.serialize.*;

import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPConnection;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPConnectionFactory;

public class SAAJAgencyClient
{
    private static String location = "%";

    public static void main(String[] args)
    {
        if (args.length == 1)
		{
            location = args[0];
		}
        else if (args.length > 1)
		{
            System.err.println("Usage: SAAJAgencyClient [ location ]");
            System.exit(1);
        }

        try
		{
            System.out.println("Using Location: " + location);

            SOAPMessage soapResponse = null;
            SOAPMessage soapRequest = null;

       	    MessageFactory messageFactory = MessageFactory.newInstance();

            SOAPConnectionFactory connectionFactory = SOAPConnectionFactory.newInstance();
            SOAPConnection connection = connectionFactory.createConnection();
            URL endpoint = new URL("http://localhost:8000/wsagency/LocationServices");

	    	// Populate message with request type of "jobsAtLocation" and location info
            soapRequest = messageFactory.createMessage();
	    	ClientMarshaler.addRequestToMessage("jobsAtLocation", location, soapRequest);

	    	// Send request
            soapResponse = connection.call(soapRequest, endpoint);

	    	// Retrieve job list from response
            System.out.println("Job list: ");
            String[] jobs = ClientMarshaler.getJobsFromMessage(soapResponse);
            for(int i = 0; i < jobs.length; i++)
	    	{
                System.out.println(jobs[i]);
            }
            
            System.out.println("\nDone\n");
        }
		catch (Exception ex)
		{
            ex.printStackTrace();
        }
    }    

	private static void dumpDOM(org.w3c.dom.Document document)
	{
		try
		{
  			OutputFormat format = new OutputFormat(document);
  			XMLSerializer output = new XMLSerializer(System.out, format);
  			output.serialize(document);
		}
		catch (java.io.IOException e)
		{
  			System.err.println(e);
		}
	}
}
